=== intern/clog/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2002-2022 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  .
  ../atomic
)

set(INC_SYS

)

set(SRC
  clog.c

  CLG_log.h
)

set(LIB
  PRIVATE bf::intern::guardedalloc
)

# Disabled for makesdna/makesrna.
add_definitions(-DWITH_CLOG_PTHREADS)

blender_add_lib(bf_intern_clog "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")
