=== debian/changelog ===
blender (4.0.2+dfsg-1ubuntu8) noble; urgency=medium

  * No-change rebuild against libimath-3-1-29t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 08 Apr 2024 05:58:39 +0000

blender (4.0.2+dfsg-1ubuntu7) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:41:54 +0000

blender (4.0.2+dfsg-1ubuntu6) noble; urgency=medium

  * No-change rebuild against libimath-3-1-29t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 16:06:58 +0000

blender (4.0.2+dfsg-1ubuntu5) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:07:14 +0000

blender (4.0.2+dfsg-1ubuntu4) noble; urgency=medium

  * Fix build with Python 3.12, patch taken from Fedora.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Jan 2024 15:25:27 +0100

blender (4.0.2+dfsg-1ubuntu3) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 21 Jan 2024 07:36:17 +0000

blender (4.0.2+dfsg-1ubuntu2) noble; urgency=medium

  * Rebuild against 'new libembree4-4'.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Jan 2024 20:33:16 +0100

blender (4.0.2+dfsg-1ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/patches: fix FTBFS on s390x and riscv64
      + 0004-double-promotion-not-error.patch added and updated
      + 0005-device-pointer-type.patch added

 -- Rik Mills <rikmills@kde.org>  Sun, 31 Dec 2023 23:13:59 +0000

blender (3.6.2+dfsg-2ubuntu2) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Dec 2023 23:15:32 +0100
